import { Consumer, FC } from 'react';
import { LiffCore, LiffError, Loginable } from './types';
interface LiffProviderProps<T> {
    liffId: string;
    stubEnabled?: boolean | Partial<T>;
}
interface LiffContext<T> {
    error?: LiffError;
    isLoggedIn: boolean;
    liff: T;
    ready: boolean;
}
declare type CreateLiffContext = <T extends LoginableLiffCore>() => {
    LiffConsumer: Consumer<LiffContext<T>>;
    LiffProvider: FC<LiffProviderProps<T>>;
    useLiff: () => LiffContext<T>;
};
declare type LoginableLiffCore = LiffCore & Loginable;
export declare const createLiffContext: CreateLiffContext;
export declare const LiffConsumer: Consumer<LiffContext<LoginableLiffCore>>, LiffProvider: FC<LiffProviderProps<LoginableLiffCore>>, useLiff: () => LiffContext<LoginableLiffCore>;
export {};
